#include "global.h"
#include "connection.h"
#include "mainsock.h"
#include "flags.h"

#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

Global::Global() {
	i_ConnectionId = 0;
	pConnectionHead = NULL;
	pConnectionTail = NULL;
	pMainSock = new MainSock;
}

Global::~Global() {
	delete pMainSock;
	// fixme: Destroying this ought to destroy all connections
}

int Global::GetNewConnectId() {

	return(i_ConnectionId++);
	//fixme: this has no provision for a clean loop
}

Connection * Global::GetConnectionHead() {
	return(pConnectionHead);
}

Connection * Global::GetConnectionTail() {
	return(pConnectionTail);
}

int Global::SetConnectionHead(class Connection *ppHead) {
	if(pConnectionHead && ppHead) return(-1);
	pConnectionHead = ppHead;
	return(0);
}

int Global::SetConnectionTail(class Connection *ppTail) {
	if(pConnectionTail && ppTail) return(-1);
	pConnectionTail = ppTail;
	return(0);
}

int Global::WriteAllPlayersExcept(Connection *pC, char *fmt, ...)
{
	// first, generate a fmt string
	Connection *pCon;
	char outbuf[1024]; // again with the cheesy shit
			// todo: bounds checking AT LEAST
	va_list ap;
	int count = 0;

	va_start(ap,fmt);
	vsprintf(outbuf,fmt,ap);
	va_end(ap);

	pCon = GetConnectionHead();

	// now, write to the players
	// todo: add spinlocking

	while(pCon) {
		if(pC != pCon && pCon->GetFlag(CFLAG_PLAYER)) {
			pCon->Write(outbuf);
			count++;
		}
	
		pCon = pCon->GetNextObj();
		
	}

	return(count);
}

int Global::WriteAllPlayers(char *fmt, ...) {
	// first, generate a fmt string
	Connection *pCon;
	char outbuf[1024]; // again with the cheesy shit
			// todo: bounds checking AT LEAST
	va_list ap;
	int count = 0;

	va_start(ap,fmt);
	vsprintf(outbuf,fmt,ap);
	va_end(ap);

	pCon = GetConnectionHead();

	// now, write to the players
	// todo: add spinlocking

	while(pCon) {
		if(pCon->GetFlag(CFLAG_PLAYER)) {
			pCon->Write(outbuf);
			count++;
		}
	
		pCon = pCon->GetNextObj();
		
	}

	return(count);
}
	
