#ifndef __parse_h
#define __parse_h


#define PARSE_ERROR_NOLINE -100

#define MAX_LINE_LEN 1024
#define LINE_ERROR_NONULL -1

#define PARSE_NONE 0
#define PARSE_COM 1
#define PARSE_SEP 2

class ParseToken {
		public:
			ParseToken();
			ParseToken(ParseToken *pHead);
			~ParseToken();
			int GetTokenNumber();
			ParseToken *GetTokenNumber(int Num);
			int GetMaxTokenNumber();


			ReleaseAll(); // very destructive function teehee
			int AddRef();
			int Release();
			int Set(char *data);
			char *Get();

			ParseToken *GetNewObj();
			ParseToken *GetPrevObj();
			ParseToken *GetNextObj();
			
		private:
			int ref_count;
			int token_number;
			char *token_buffer;
			ParseToken *pHead;
			ParseToken *pNext;
			ParseToken *pPrev;
};

class ParseLine {
		public:
			ParseLine(ParseLine *pPrev);
			ParseLine();
			~ParseLine();
			int Set(char *);
			char *Get();
			int GetParseLine();
			ParseLine *GetPrevObj();
			ParseLine *GetNextObj();
			ParseLine *GetNewObj();
			ParseToken *Parse();
			ParseToken *Parse(char *Sep, char *Com);

		private:
			int VerifyNull(char *data);
			int line_number;
			char *line_buffer;
			ParseLine *pPrev;
			ParseLine *pNext;
			ParseLine *pHead;
			ParseToken *ptHead;
};


#endif
